#include <stdio.h>
#include <imsls.h>

int main(){    
   Imsls_f_NN_Network *network;
   int i, j, k, m;
   int n_patterns    =24;    /* no. of training patterns */
   int n_nvars       =2;     /* 2 nominal unencoded variables */
   int n_nominal     =7;     /* 7 inputs for the binary encoded 
                                nominal vars */
   int n_continuous  =2;     /* 2 continuous input attributes */
   int nominalIn[24];        /* work arrays used to encode    */
   int *nominalOut;          /* nominal data                  */
   int n_classes;  
   int classification[24] = {
      0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1,
         0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1
   };
   /* raw nominal input data */
   int nominal_unencododed[2*24] =
   {
      0, 0, 0, 1, 0, 2,
         1, 0, 1, 1, 1, 2,
         2, 0, 2, 1, 2, 2,
         3, 0, 3, 1, 3, 2,
         0, 0, 0, 1, 0, 2,
         1, 0, 1, 1, 1, 2,
         2, 0, 2, 1, 2, 2,
         3, 0, 3, 1, 3, 2
   };

   /* input array for binary encoded version of 
      nominal_unencododed[] array above */
   int nominal[7*24];
   float *weights;
   float continuous[2*24] =
   {
      0.00,0.00,0.02,0.02,0.04,0.04,0.06,0.06,0.08,0.08,0.10,0.10,
         0.12,0.12,0.14,0.14,0.16,0.16,0.18,0.18,0.20,0.20,0.22,0.22,
         0.24,0.28,0.26,0.30,0.28,0.32,0.30,0.34,0.32,0.36,0.34,0.38,
         0.36,0.40,0.38,0.42,0.40,0.44,0.42,0.46,0.44,0.48,0.46,0.50
   };

   /* Setup Nominal Input Attributes Using Binary Encoding */
   m=0;
   for (i=0; i<n_nvars; i++){
      for (j=0; j<n_patterns; j++) {
         nominalIn[j] = nominal_unencododed[2*j+i] + 1;
      }
      nominalOut = imsls_unsupervised_nominal_filter(n_patterns, 
         &n_classes, nominalIn, 0);
      for(k=0; k<n_classes; k++){
         for(j=0; j<n_patterns; j++){
            nominal[j*n_nominal+m] = nominalOut[j*n_classes+k];
         }
         m++;
      }
   }
   printf("\tINPUT TRAINING PATTERNS\n");
   printf("\tY   Nom1 Nom2    X0     X1 \n");
   for(i=0; i<n_patterns; i++){
      printf("\t%d   %d \t %d    %f   %f \n", classification[i],
         nominal_unencododed[i*2], nominal_unencododed[i*2+1], 
         continuous[i*2], continuous[i*2+1]);
   }

   /* Binary classification network 9 inputs 1 output = 2 classes */
   network = imsls_f_mlff_network_init(9, 1);
   imsls_f_mlff_network(network, IMSLS_CREATE_HIDDEN_LAYER, 3, 0);
   imsls_f_mlff_network(network, IMSLS_CREATE_HIDDEN_LAYER, 2, 
      IMSLS_LINK_ALL, 0);

   /* Note the following statement is for repeatable output */
   imsls_random_seed_set(5555);

   /* Random Weights */
   weights = imsls_f_mlff_initialize_weights(network, n_patterns,
      n_nominal, n_continuous, nominal, continuous, 
      IMSLS_PRINT, 0);

